import { h } from "@stencil/core";
export class DatatableFooter {
    componentWillLoad() {
        this.actions = Array.from(this.host.querySelectorAll('materials-datatable-action'));
    }
    render() {
        return (h("div", { class: "container" }, this.actions && this.actions.length > 0 ? this.actions.map(a => {
            return a.display && h("materials-button", { raised: true, color: a.color, icon: a.icon, onClick: (e) => a.TriggerPress(e) }, a.label);
        })
            :
                h("slot", null)));
    }
    static get is() { return "materials-datatable-footer"; }
    static get encapsulation() { return "shadow"; }
    static get originalStyleUrls() { return {
        "$": ["datatable-footer.scss"]
    }; }
    static get styleUrls() { return {
        "$": ["datatable-footer.css"]
    }; }
    static get properties() { return {
        "color": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "'primary' | 'secondary'",
                "resolved": "\"primary\" | \"secondary\"",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "color",
            "reflect": false
        }
    }; }
    static get elementRef() { return "host"; }
}
