import { h } from "@stencil/core";
export class Headline {
    getClasses() {
        const classes = { 'mdc-typography': true };
        classes['mdc-typography--headline' + this.level] = true;
        return classes;
    }
    render() {
        return (h("header", { class: this.getClasses() },
            h("slot", null)));
    }
    static get is() { return "materials-headline"; }
    static get encapsulation() { return "shadow"; }
    static get originalStyleUrls() { return {
        "$": ["headline.scss"]
    }; }
    static get styleUrls() { return {
        "$": ["headline.css"]
    }; }
    static get properties() { return {
        "level": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "'1' | '2' | '3' | '4' | '5' | '6'",
                "resolved": "\"1\" | \"2\" | \"3\" | \"4\" | \"5\" | \"6\"",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "level",
            "reflect": false
        }
    }; }
}
