import { h } from "@stencil/core";
export class Subtitle {
    getClasses() {
        const classes = { 'mdc-typography': true };
        classes['mdc-typography--subtitle' + this.level] = true;
        return classes;
    }
    render() {
        return (h("div", { class: this.getClasses() },
            h("slot", null)));
    }
    static get is() { return "materials-subtitle"; }
    static get encapsulation() { return "shadow"; }
    static get originalStyleUrls() { return {
        "$": ["subtitle.scss"]
    }; }
    static get styleUrls() { return {
        "$": ["subtitle.css"]
    }; }
    static get properties() { return {
        "level": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "'1' | '2'",
                "resolved": "\"1\" | \"2\"",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "level",
            "reflect": false
        }
    }; }
}
