var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
import { r as registerInstance, h, H as Host, g as getElement } from './index-0b18a276.js';
import './index-0d98f647.js';
import { M as MDCDrawer } from './index-fefe7b63.js';
import './component-e22d7bf7.js';
import './ponyfill-f805c928.js';
import { M as MDCTopAppBar } from './index-4fadbdc3.js';
var DrawerWithTopAppBar = /** @class */ (function () {
    function class_1(hostRef) {
        registerInstance(this, hostRef);
        this.drawerType = 'fullHeight';
        this.appBarType = 'standard';
    }
    class_1.prototype.componentWillLoad = function () {
        var _this = this;
        // Observe host childList mutations
        new MutationObserver(function (mutationsList, _observer) {
            for (var _i = 0, mutationsList_1 = mutationsList; _i < mutationsList_1.length; _i++) {
                var mutation = mutationsList_1[_i];
                if (mutation.type === 'childList') {
                    _this.initActions();
                    _this.initDrawerItems();
                }
            }
        }).observe(this.host, { attributes: false, childList: true, subtree: false });
        this.initActions();
        this.initDrawerItems();
    };
    class_1.prototype.componentDidLoad = function () {
        return __awaiter(this, void 0, void 0, function () {
            var topAppBar;
            var _this = this;
            return __generator(this, function (_a) {
                if (!this.drawer) {
                    this.drawer = MDCDrawer.attachTo(this.host.shadowRoot.querySelector('.mdc-drawer'));
                    this.drawer.open = this.open;
                    topAppBar = MDCTopAppBar.attachTo(this.host.shadowRoot.getElementById('app-bar'));
                    if (this.drawerType !== 'modal') {
                        topAppBar.setScrollTarget(this.host.shadowRoot.getElementById('main-content'));
                    }
                    topAppBar.listen('MDCTopAppBar:nav', function () {
                        _this.drawer.open = !_this.drawer.open;
                    });
                }
                return [2 /*return*/];
            });
        });
    };
    class_1.prototype.initActions = function () {
        var _this = this;
        this.actions = Array.from(this.host.querySelectorAll('materials-top-app-bar-action'));
        // Init existing action observation
        this.actions.forEach(function (node) {
            new MutationObserver(function (mutationsList, _observer) {
                for (var _i = 0, mutationsList_2 = mutationsList; _i < mutationsList_2.length; _i++) {
                    var mutation = mutationsList_2[_i];
                    if (mutation.type === 'attributes') {
                        _this.actions = __spreadArrays(_this.actions);
                    }
                }
            }).observe(node, { attributes: true, childList: false, subtree: false });
        });
    };
    class_1.prototype.initDrawerItems = function () {
        var _this = this;
        this.items = Array.from(this.host.querySelectorAll('materials-drawer-list-item'));
        // Init existing action observation
        this.items.forEach(function (node) {
            new MutationObserver(function (mutationsList, _observer) {
                for (var _i = 0, mutationsList_3 = mutationsList; _i < mutationsList_3.length; _i++) {
                    var mutation = mutationsList_3[_i];
                    if (mutation.type === 'attributes') {
                        _this.items = __spreadArrays(_this.items);
                    }
                }
            }).observe(node, { attributes: true, childList: false, subtree: false });
        });
    };
    class_1.prototype.renderAppBar = function () {
        var classes = {
            'mdc-top-app-bar': true,
            'mdc-top-app-bar--short': this.appBarType === 'short' || this.appBarType === 'short-closed',
            'mdc-top-app-bar--fixed': this.appBarType === 'fixed',
            'mdc-top-app-bar--prominent': this.appBarType === 'prominent',
            'mdc-top-app-bar--dense': this.appBarDense,
            'mdc-top-app-bar--short-collapsed': this.appBarType === 'short-closed',
        };
        return (h("header", { class: classes, id: "app-bar" }, h("div", { class: "mdc-top-app-bar__row" }, h("section", { class: "mdc-top-app-bar__section mdc-top-app-bar__section--align-start" }, h("a", { class: "demo-menu material-icons mdc-top-app-bar__navigation-icon" }, "menu"), h("span", { class: "mdc-top-app-bar__title" }, this.appBarTitle)), h("section", { class: "mdc-top-app-bar__section mdc-top-app-bar__section--align-end", role: "toolbar" }, this.actions.map(function (a) { return h("a", { href: "#", onClick: function () { return a.click(); }, class: "material-icons mdc-top-app-bar__action-item", "aria-label": a.title, title: a.title }, a.icon); })))));
    };
    class_1.prototype.renderDrawerItem = function (item) {
        return h("a", { class: {
                'mdc-list-item': true,
                'mdc-list-item--activated': item.activated
            }, href: item.targetUrl, onClick: function (e) { item.TriggerPress(e); }, "aria-current": "page" }, item.icon && h("i", { class: "material-icons mdc-list-item__graphic", "aria-hidden": "true" }, item.icon), h("span", { class: "mdc-list-item__text" }, item.label));
    };
    class_1.prototype.renderModal = function () {
        var _this = this;
        return [
            this.renderAppBar(),
            h("aside", { class: "mdc-drawer mdc-drawer--modal" }, h("div", { class: "mdc-drawer__content" }, h("nav", { class: "mdc-list" }, this.items.map(function (item) { return _this.renderDrawerItem(item); })))),
            h("div", { class: "mdc-drawer-scrim" }),
            h("div", null, h("slot", { name: "main" }))
        ];
    };
    class_1.prototype.renderFull = function () {
        var _this = this;
        return [
            h("aside", { class: "mdc-drawer mdc-drawer--dismissible" }, h("div", { class: "mdc-drawer__content" }, h("div", { class: "mdc-list" }, this.items.map(function (item) { return _this.renderDrawerItem(item); })))),
            h("div", { class: "mdc-drawer-app-content" }, this.renderAppBar(), h("main", { class: "main-content", id: "main-content" }, h("div", { class: "mdc-top-app-bar--fixed-adjust" }, h("slot", { name: "main" }))))
        ];
    };
    class_1.prototype.renderBelow = function () {
        var _this = this;
        return [
            this.renderAppBar(),
            h("aside", { class: "mdc-drawer mdc-drawer--dismissible mdc-top-app-bar--fixed-adjust" }, h("div", { class: "mdc-drawer__content" }, h("div", { class: "mdc-list" }, this.items.map(function (item) { return _this.renderDrawerItem(item); })))),
            h("div", { class: "mdc-drawer-app-content mdc-top-app-bar--fixed-adjust" }, h("main", { class: "main-content", id: "main-content" }, h("slot", { name: "main" })))
        ];
    };
    class_1.prototype.render = function () {
        switch (this.drawerType) {
            case 'modal':
                return h(Host, null, this.renderModal());
            case 'below':
                return h(Host, { class: { 'materials-drawer--below': true } }, this.renderBelow());
            case 'fullHeight':
                return h(Host, null, this.renderFull());
        }
    };
    Object.defineProperty(class_1.prototype, "host", {
        get: function () { return getElement(this); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(class_1, "style", {
        get: function () { return ".mdc-list{font-family:Roboto,sans-serif;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;font-size:1rem;line-height:1.75rem;font-weight:400;letter-spacing:0.009375em;text-decoration:inherit;text-transform:inherit;line-height:1.5rem;margin:0;padding:8px 0;list-style-type:none;color:rgba(0,0,0,0.87);color:var(--mdc-theme-text-primary-on-background,rgba(0,0,0,0.87));}.mdc-list:focus{outline:none;}.mdc-list-item__secondary-text{color:rgba(0,0,0,0.54);color:var(--mdc-theme-text-secondary-on-background,rgba(0,0,0,0.54));}.mdc-list-item__graphic{background-color:transparent;}.mdc-list-item__graphic{color:rgba(0,0,0,0.38);color:var(--mdc-theme-text-icon-on-background,rgba(0,0,0,0.38));}.mdc-list-item__meta{color:rgba(0,0,0,0.38);color:var(--mdc-theme-text-hint-on-background,rgba(0,0,0,0.38));}.mdc-list-group__subheader{color:rgba(0,0,0,0.87);color:var(--mdc-theme-text-primary-on-background,rgba(0,0,0,0.87));}.mdc-list--dense{padding-top:4px;padding-bottom:4px;font-size:0.812rem;}.mdc-list-item{display:-ms-flexbox;display:flex;position:relative;-ms-flex-align:center;align-items:center;-ms-flex-pack:start;justify-content:flex-start;height:48px;padding:0 16px;overflow:hidden;}.mdc-list-item:focus{outline:none;}.mdc-list-item--selected,.mdc-list-item--activated{color:#6200ee;color:var(--mdc-theme-primary,#6200ee);}.mdc-list-item--selected .mdc-list-item__graphic,.mdc-list-item--activated .mdc-list-item__graphic{color:#6200ee;color:var(--mdc-theme-primary,#6200ee);}.mdc-list-item--disabled{color:rgba(0,0,0,0.38);color:var(--mdc-theme-text-disabled-on-background,rgba(0,0,0,0.38));}.mdc-list-item__graphic{margin-left:0;margin-right:32px;width:24px;height:24px;-ms-flex-negative:0;flex-shrink:0;-ms-flex-align:center;align-items:center;-ms-flex-pack:center;justify-content:center;fill:currentColor;}.mdc-list-item[dir=rtl] .mdc-list-item__graphic,[dir=rtl] .mdc-list-item .mdc-list-item__graphic{margin-left:32px;margin-right:0;}.mdc-list .mdc-list-item__graphic{display:-ms-inline-flexbox;display:inline-flex;}.mdc-list-item__meta{margin-left:auto;margin-right:0;}.mdc-list-item__meta:not(.material-icons){font-family:Roboto,sans-serif;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;font-size:0.75rem;line-height:1.25rem;font-weight:400;letter-spacing:0.0333333333em;text-decoration:inherit;text-transform:inherit;}.mdc-list-item[dir=rtl] .mdc-list-item__meta,[dir=rtl] .mdc-list-item .mdc-list-item__meta{margin-left:0;margin-right:auto;}.mdc-list-item__text{text-overflow:ellipsis;white-space:nowrap;overflow:hidden;}.mdc-list-item__text[for]{pointer-events:none;}.mdc-list-item__primary-text{text-overflow:ellipsis;white-space:nowrap;overflow:hidden;display:block;margin-top:0;line-height:normal;margin-bottom:-20px;display:block;}.mdc-list-item__primary-text::before{display:inline-block;width:0;height:32px;content:\"\";vertical-align:0;}.mdc-list-item__primary-text::after{display:inline-block;width:0;height:20px;content:\"\";vertical-align:-20px;}.mdc-list--dense .mdc-list-item__primary-text{display:block;margin-top:0;line-height:normal;margin-bottom:-20px;}.mdc-list--dense .mdc-list-item__primary-text::before{display:inline-block;width:0;height:24px;content:\"\";vertical-align:0;}.mdc-list--dense .mdc-list-item__primary-text::after{display:inline-block;width:0;height:20px;content:\"\";vertical-align:-20px;}.mdc-list-item__secondary-text{font-family:Roboto,sans-serif;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;font-size:0.875rem;line-height:1.25rem;font-weight:400;letter-spacing:0.0178571429em;text-decoration:inherit;text-transform:inherit;text-overflow:ellipsis;white-space:nowrap;overflow:hidden;display:block;margin-top:0;line-height:normal;display:block;}.mdc-list-item__secondary-text::before{display:inline-block;width:0;height:20px;content:\"\";vertical-align:0;}.mdc-list--dense .mdc-list-item__secondary-text{display:block;margin-top:0;line-height:normal;font-size:inherit;}.mdc-list--dense .mdc-list-item__secondary-text::before{display:inline-block;width:0;height:20px;content:\"\";vertical-align:0;}.mdc-list--dense .mdc-list-item{height:40px;}.mdc-list--dense .mdc-list-item__graphic{margin-left:0;margin-right:36px;width:20px;height:20px;}.mdc-list-item[dir=rtl] .mdc-list--dense .mdc-list-item__graphic,[dir=rtl] .mdc-list-item .mdc-list--dense .mdc-list-item__graphic{margin-left:36px;margin-right:0;}.mdc-list--avatar-list .mdc-list-item{height:56px;}.mdc-list--avatar-list .mdc-list-item__graphic{margin-left:0;margin-right:16px;width:40px;height:40px;border-radius:50%;}.mdc-list-item[dir=rtl] .mdc-list--avatar-list .mdc-list-item__graphic,[dir=rtl] .mdc-list-item .mdc-list--avatar-list .mdc-list-item__graphic{margin-left:16px;margin-right:0;}.mdc-list--two-line .mdc-list-item__text{-ms-flex-item-align:start;align-self:flex-start;}.mdc-list--two-line .mdc-list-item{height:72px;}.mdc-list--two-line.mdc-list--dense .mdc-list-item,.mdc-list--avatar-list.mdc-list--dense .mdc-list-item{height:60px;}.mdc-list--avatar-list.mdc-list--dense .mdc-list-item__graphic{margin-left:0;margin-right:20px;width:36px;height:36px;}.mdc-list-item[dir=rtl] .mdc-list--avatar-list.mdc-list--dense .mdc-list-item__graphic,[dir=rtl] .mdc-list-item .mdc-list--avatar-list.mdc-list--dense .mdc-list-item__graphic{margin-left:20px;margin-right:0;}:not(.mdc-list--non-interactive) >:not(.mdc-list-item--disabled).mdc-list-item{cursor:pointer;}a.mdc-list-item{color:inherit;text-decoration:none;}.mdc-list-divider{height:0;margin:0;border:none;border-bottom-width:1px;border-bottom-style:solid;}.mdc-list-divider{border-bottom-color:rgba(0,0,0,0.12);}.mdc-list-divider--padded{margin:0 16px;}.mdc-list-divider--inset{margin-left:72px;margin-right:0;width:calc(100% - 72px);}.mdc-list-group[dir=rtl] .mdc-list-divider--inset,[dir=rtl] .mdc-list-group .mdc-list-divider--inset{margin-left:0;margin-right:72px;}.mdc-list-divider--inset.mdc-list-divider--padded{width:calc(100% - 72px - 16px);}.mdc-list-group .mdc-list{padding:0;}.mdc-list-group__subheader{font-family:Roboto,sans-serif;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;font-size:1rem;line-height:1.75rem;font-weight:400;letter-spacing:0.009375em;text-decoration:inherit;text-transform:inherit;margin:0.75rem 16px;}\@-webkit-keyframes mdc-ripple-fg-radius-in{from{-webkit-animation-timing-function:cubic-bezier(0.4,0,0.2,1);animation-timing-function:cubic-bezier(0.4,0,0.2,1);-webkit-transform:translate(var(--mdc-ripple-fg-translate-start,0)) scale(1);transform:translate(var(--mdc-ripple-fg-translate-start,0)) scale(1);}to{-webkit-transform:translate(var(--mdc-ripple-fg-translate-end,0)) scale(var(--mdc-ripple-fg-scale,1));transform:translate(var(--mdc-ripple-fg-translate-end,0)) scale(var(--mdc-ripple-fg-scale,1));}}\@keyframes mdc-ripple-fg-radius-in{from{-webkit-animation-timing-function:cubic-bezier(0.4,0,0.2,1);animation-timing-function:cubic-bezier(0.4,0,0.2,1);-webkit-transform:translate(var(--mdc-ripple-fg-translate-start,0)) scale(1);transform:translate(var(--mdc-ripple-fg-translate-start,0)) scale(1);}to{-webkit-transform:translate(var(--mdc-ripple-fg-translate-end,0)) scale(var(--mdc-ripple-fg-scale,1));transform:translate(var(--mdc-ripple-fg-translate-end,0)) scale(var(--mdc-ripple-fg-scale,1));}}\@-webkit-keyframes mdc-ripple-fg-opacity-in{from{-webkit-animation-timing-function:linear;animation-timing-function:linear;opacity:0;}to{opacity:var(--mdc-ripple-fg-opacity,0);}}\@keyframes mdc-ripple-fg-opacity-in{from{-webkit-animation-timing-function:linear;animation-timing-function:linear;opacity:0;}to{opacity:var(--mdc-ripple-fg-opacity,0);}}\@-webkit-keyframes mdc-ripple-fg-opacity-out{from{-webkit-animation-timing-function:linear;animation-timing-function:linear;opacity:var(--mdc-ripple-fg-opacity,0);}to{opacity:0;}}\@keyframes mdc-ripple-fg-opacity-out{from{-webkit-animation-timing-function:linear;animation-timing-function:linear;opacity:var(--mdc-ripple-fg-opacity,0);}to{opacity:0;}}.mdc-ripple-surface--test-edge-var-bug{--mdc-ripple-surface-test-edge-var:1px solid #000;visibility:hidden;}.mdc-ripple-surface--test-edge-var-bug::before{border:var(--mdc-ripple-surface-test-edge-var);}:not(.mdc-list--non-interactive) >:not(.mdc-list-item--disabled).mdc-list-item{--mdc-ripple-fg-size:0;--mdc-ripple-left:0;--mdc-ripple-top:0;--mdc-ripple-fg-scale:1;--mdc-ripple-fg-translate-end:0;--mdc-ripple-fg-translate-start:0;-webkit-tap-highlight-color:rgba(0,0,0,0);}:not(.mdc-list--non-interactive) >:not(.mdc-list-item--disabled).mdc-list-item::before,:not(.mdc-list--non-interactive) >:not(.mdc-list-item--disabled).mdc-list-item::after{position:absolute;border-radius:50%;opacity:0;pointer-events:none;content:\"\";}:not(.mdc-list--non-interactive) >:not(.mdc-list-item--disabled).mdc-list-item::before{-webkit-transition:opacity 15ms linear,background-color 15ms linear;transition:opacity 15ms linear,background-color 15ms linear;z-index:1;}:not(.mdc-list--non-interactive) >:not(.mdc-list-item--disabled).mdc-list-item.mdc-ripple-upgraded::before{-webkit-transform:scale(var(--mdc-ripple-fg-scale,1));transform:scale(var(--mdc-ripple-fg-scale,1));}:not(.mdc-list--non-interactive) >:not(.mdc-list-item--disabled).mdc-list-item.mdc-ripple-upgraded::after{top:0;left:0;-webkit-transform:scale(0);transform:scale(0);-webkit-transform-origin:center center;transform-origin:center center;}:not(.mdc-list--non-interactive) >:not(.mdc-list-item--disabled).mdc-list-item.mdc-ripple-upgraded--unbounded::after{top:var(--mdc-ripple-top,0);left:var(--mdc-ripple-left,0);}:not(.mdc-list--non-interactive) >:not(.mdc-list-item--disabled).mdc-list-item.mdc-ripple-upgraded--foreground-activation::after{-webkit-animation:mdc-ripple-fg-radius-in 225ms forwards,mdc-ripple-fg-opacity-in 75ms forwards;animation:mdc-ripple-fg-radius-in 225ms forwards,mdc-ripple-fg-opacity-in 75ms forwards;}:not(.mdc-list--non-interactive) >:not(.mdc-list-item--disabled).mdc-list-item.mdc-ripple-upgraded--foreground-deactivation::after{-webkit-animation:mdc-ripple-fg-opacity-out 150ms;animation:mdc-ripple-fg-opacity-out 150ms;-webkit-transform:translate(var(--mdc-ripple-fg-translate-end,0)) scale(var(--mdc-ripple-fg-scale,1));transform:translate(var(--mdc-ripple-fg-translate-end,0)) scale(var(--mdc-ripple-fg-scale,1));}:not(.mdc-list--non-interactive) >:not(.mdc-list-item--disabled).mdc-list-item::before,:not(.mdc-list--non-interactive) >:not(.mdc-list-item--disabled).mdc-list-item::after{top:calc(50% - 100%);left:calc(50% - 100%);width:200%;height:200%;}:not(.mdc-list--non-interactive) >:not(.mdc-list-item--disabled).mdc-list-item.mdc-ripple-upgraded::after{width:var(--mdc-ripple-fg-size,100%);height:var(--mdc-ripple-fg-size,100%);}:not(.mdc-list--non-interactive) >:not(.mdc-list-item--disabled).mdc-list-item::before,:not(.mdc-list--non-interactive) >:not(.mdc-list-item--disabled).mdc-list-item::after{background-color:#000;}:not(.mdc-list--non-interactive) >:not(.mdc-list-item--disabled).mdc-list-item:hover::before{opacity:0.04;}:not(.mdc-list--non-interactive) >:not(.mdc-list-item--disabled).mdc-list-item:not(.mdc-ripple-upgraded):focus::before,:not(.mdc-list--non-interactive) >:not(.mdc-list-item--disabled).mdc-list-item.mdc-ripple-upgraded--background-focused::before{-webkit-transition-duration:75ms;transition-duration:75ms;opacity:0.12;}:not(.mdc-list--non-interactive) >:not(.mdc-list-item--disabled).mdc-list-item:not(.mdc-ripple-upgraded)::after{-webkit-transition:opacity 150ms linear;transition:opacity 150ms linear;}:not(.mdc-list--non-interactive) >:not(.mdc-list-item--disabled).mdc-list-item:not(.mdc-ripple-upgraded):active::after{-webkit-transition-duration:75ms;transition-duration:75ms;opacity:0.12;}:not(.mdc-list--non-interactive) >:not(.mdc-list-item--disabled).mdc-list-item.mdc-ripple-upgraded{--mdc-ripple-fg-opacity:0.12;}:not(.mdc-list--non-interactive) >:not(.mdc-list-item--disabled).mdc-list-item--activated::before{opacity:0.12;}:not(.mdc-list--non-interactive) >:not(.mdc-list-item--disabled).mdc-list-item--activated::before,:not(.mdc-list--non-interactive) >:not(.mdc-list-item--disabled).mdc-list-item--activated::after{background-color:#6200ee;}\@supports not (-ms-ime-align:auto){:not(.mdc-list--non-interactive) >:not(.mdc-list-item--disabled).mdc-list-item--activated::before,:not(.mdc-list--non-interactive) >:not(.mdc-list-item--disabled).mdc-list-item--activated::after{background-color:var(--mdc-theme-primary,#6200ee);}}:not(.mdc-list--non-interactive) >:not(.mdc-list-item--disabled).mdc-list-item--activated:hover::before{opacity:0.16;}:not(.mdc-list--non-interactive) >:not(.mdc-list-item--disabled).mdc-list-item--activated:not(.mdc-ripple-upgraded):focus::before,:not(.mdc-list--non-interactive) >:not(.mdc-list-item--disabled).mdc-list-item--activated.mdc-ripple-upgraded--background-focused::before{-webkit-transition-duration:75ms;transition-duration:75ms;opacity:0.24;}:not(.mdc-list--non-interactive) >:not(.mdc-list-item--disabled).mdc-list-item--activated:not(.mdc-ripple-upgraded)::after{-webkit-transition:opacity 150ms linear;transition:opacity 150ms linear;}:not(.mdc-list--non-interactive) >:not(.mdc-list-item--disabled).mdc-list-item--activated:not(.mdc-ripple-upgraded):active::after{-webkit-transition-duration:75ms;transition-duration:75ms;opacity:0.24;}:not(.mdc-list--non-interactive) >:not(.mdc-list-item--disabled).mdc-list-item--activated.mdc-ripple-upgraded{--mdc-ripple-fg-opacity:0.24;}:not(.mdc-list--non-interactive) >:not(.mdc-list-item--disabled).mdc-list-item--selected::before{opacity:0.08;}:not(.mdc-list--non-interactive) >:not(.mdc-list-item--disabled).mdc-list-item--selected::before,:not(.mdc-list--non-interactive) >:not(.mdc-list-item--disabled).mdc-list-item--selected::after{background-color:#6200ee;}\@supports not (-ms-ime-align:auto){:not(.mdc-list--non-interactive) >:not(.mdc-list-item--disabled).mdc-list-item--selected::before,:not(.mdc-list--non-interactive) >:not(.mdc-list-item--disabled).mdc-list-item--selected::after{background-color:var(--mdc-theme-primary,#6200ee);}}:not(.mdc-list--non-interactive) >:not(.mdc-list-item--disabled).mdc-list-item--selected:hover::before{opacity:0.12;}:not(.mdc-list--non-interactive) >:not(.mdc-list-item--disabled).mdc-list-item--selected:not(.mdc-ripple-upgraded):focus::before,:not(.mdc-list--non-interactive) >:not(.mdc-list-item--disabled).mdc-list-item--selected.mdc-ripple-upgraded--background-focused::before{-webkit-transition-duration:75ms;transition-duration:75ms;opacity:0.2;}:not(.mdc-list--non-interactive) >:not(.mdc-list-item--disabled).mdc-list-item--selected:not(.mdc-ripple-upgraded)::after{-webkit-transition:opacity 150ms linear;transition:opacity 150ms linear;}:not(.mdc-list--non-interactive) >:not(.mdc-list-item--disabled).mdc-list-item--selected:not(.mdc-ripple-upgraded):active::after{-webkit-transition-duration:75ms;transition-duration:75ms;opacity:0.2;}:not(.mdc-list--non-interactive) >:not(.mdc-list-item--disabled).mdc-list-item--selected.mdc-ripple-upgraded{--mdc-ripple-fg-opacity:0.2;}:not(.mdc-list--non-interactive) > .mdc-list-item--disabled{--mdc-ripple-fg-size:0;--mdc-ripple-left:0;--mdc-ripple-top:0;--mdc-ripple-fg-scale:1;--mdc-ripple-fg-translate-end:0;--mdc-ripple-fg-translate-start:0;-webkit-tap-highlight-color:rgba(0,0,0,0);}:not(.mdc-list--non-interactive) > .mdc-list-item--disabled::before,:not(.mdc-list--non-interactive) > .mdc-list-item--disabled::after{position:absolute;border-radius:50%;opacity:0;pointer-events:none;content:\"\";}:not(.mdc-list--non-interactive) > .mdc-list-item--disabled::before{-webkit-transition:opacity 15ms linear,background-color 15ms linear;transition:opacity 15ms linear,background-color 15ms linear;z-index:1;}:not(.mdc-list--non-interactive) > .mdc-list-item--disabled.mdc-ripple-upgraded::before{-webkit-transform:scale(var(--mdc-ripple-fg-scale,1));transform:scale(var(--mdc-ripple-fg-scale,1));}:not(.mdc-list--non-interactive) > .mdc-list-item--disabled.mdc-ripple-upgraded::after{top:0;left:0;-webkit-transform:scale(0);transform:scale(0);-webkit-transform-origin:center center;transform-origin:center center;}:not(.mdc-list--non-interactive) > .mdc-list-item--disabled.mdc-ripple-upgraded--unbounded::after{top:var(--mdc-ripple-top,0);left:var(--mdc-ripple-left,0);}:not(.mdc-list--non-interactive) > .mdc-list-item--disabled.mdc-ripple-upgraded--foreground-activation::after{-webkit-animation:mdc-ripple-fg-radius-in 225ms forwards,mdc-ripple-fg-opacity-in 75ms forwards;animation:mdc-ripple-fg-radius-in 225ms forwards,mdc-ripple-fg-opacity-in 75ms forwards;}:not(.mdc-list--non-interactive) > .mdc-list-item--disabled.mdc-ripple-upgraded--foreground-deactivation::after{-webkit-animation:mdc-ripple-fg-opacity-out 150ms;animation:mdc-ripple-fg-opacity-out 150ms;-webkit-transform:translate(var(--mdc-ripple-fg-translate-end,0)) scale(var(--mdc-ripple-fg-scale,1));transform:translate(var(--mdc-ripple-fg-translate-end,0)) scale(var(--mdc-ripple-fg-scale,1));}:not(.mdc-list--non-interactive) > .mdc-list-item--disabled::before,:not(.mdc-list--non-interactive) > .mdc-list-item--disabled::after{top:calc(50% - 100%);left:calc(50% - 100%);width:200%;height:200%;}:not(.mdc-list--non-interactive) > .mdc-list-item--disabled.mdc-ripple-upgraded::after{width:var(--mdc-ripple-fg-size,100%);height:var(--mdc-ripple-fg-size,100%);}:not(.mdc-list--non-interactive) > .mdc-list-item--disabled::before,:not(.mdc-list--non-interactive) > .mdc-list-item--disabled::after{background-color:#000;}:not(.mdc-list--non-interactive) > .mdc-list-item--disabled:not(.mdc-ripple-upgraded):focus::before,:not(.mdc-list--non-interactive) > .mdc-list-item--disabled.mdc-ripple-upgraded--background-focused::before{-webkit-transition-duration:75ms;transition-duration:75ms;opacity:0.12;}.mdc-drawer{border-color:rgba(0,0,0,0.12);background-color:#fff;border-radius:0 0 0 0;z-index:6;width:256px;display:-ms-flexbox;display:flex;-ms-flex-direction:column;flex-direction:column;-ms-flex-negative:0;flex-shrink:0;-webkit-box-sizing:border-box;box-sizing:border-box;height:100%;-webkit-transition-property:-webkit-transform;transition-property:-webkit-transform;transition-property:transform;transition-property:transform,-webkit-transform;-webkit-transition-timing-function:cubic-bezier(0.4,0,0.2,1);transition-timing-function:cubic-bezier(0.4,0,0.2,1);border-right-width:1px;border-right-style:solid;overflow:hidden;}.mdc-drawer .mdc-drawer__title{color:rgba(0,0,0,0.87);}.mdc-drawer .mdc-list-group__subheader{color:rgba(0,0,0,0.6);}.mdc-drawer .mdc-drawer__subtitle{color:rgba(0,0,0,0.6);}.mdc-drawer .mdc-list-item__graphic{color:rgba(0,0,0,0.6);}.mdc-drawer .mdc-list-item{color:rgba(0,0,0,0.87);}.mdc-drawer .mdc-list-item--activated .mdc-list-item__graphic{color:#6200ee;}.mdc-drawer .mdc-list-item--activated{color:rgba(98,0,238,0.87);}[dir=rtl] .mdc-drawer,.mdc-drawer[dir=rtl]{border-radius:0 0 0 0;}.mdc-drawer .mdc-list-item{border-radius:4px;}.mdc-drawer.mdc-drawer--open:not(.mdc-drawer--closing)+.mdc-drawer-app-content{margin-left:256px;margin-right:0;}[dir=rtl] .mdc-drawer.mdc-drawer--open:not(.mdc-drawer--closing)+.mdc-drawer-app-content,.mdc-drawer.mdc-drawer--open:not(.mdc-drawer--closing)+.mdc-drawer-app-content[dir=rtl]{margin-left:0;margin-right:256px;}[dir=rtl] .mdc-drawer,.mdc-drawer[dir=rtl]{border-right-width:0;border-left-width:1px;border-right-style:none;border-left-style:solid;}.mdc-drawer .mdc-list-item{font-family:Roboto,sans-serif;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;font-size:0.875rem;line-height:1.375rem;font-weight:500;letter-spacing:0.0071428571em;text-decoration:inherit;text-transform:inherit;height:calc(48px - 2 * 4px);margin:8px 8px;padding:0 8px;}.mdc-drawer .mdc-list-item:nth-child(1){margin-top:2px;}.mdc-drawer .mdc-list-item:nth-last-child(1){margin-bottom:0;}.mdc-drawer .mdc-list-group__subheader{font-family:Roboto,sans-serif;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;font-size:0.875rem;line-height:1.25rem;font-weight:400;letter-spacing:0.0178571429em;text-decoration:inherit;text-transform:inherit;display:block;margin-top:0;line-height:normal;margin:0;padding:0 16px;}.mdc-drawer .mdc-list-group__subheader::before{display:inline-block;width:0;height:24px;content:\"\";vertical-align:0;}.mdc-drawer .mdc-list-divider{margin:3px 0 4px 0;}.mdc-drawer .mdc-list-item__text,.mdc-drawer .mdc-list-item__graphic{pointer-events:none;}.mdc-drawer--animate{-webkit-transform:translateX(-100%);transform:translateX(-100%);}[dir=rtl] .mdc-drawer--animate,.mdc-drawer--animate[dir=rtl]{-webkit-transform:translateX(100%);transform:translateX(100%);}.mdc-drawer--opening{-webkit-transform:translateX(0);transform:translateX(0);-webkit-transition-duration:250ms;transition-duration:250ms;}[dir=rtl] .mdc-drawer--opening,.mdc-drawer--opening[dir=rtl]{-webkit-transform:translateX(0);transform:translateX(0);}.mdc-drawer--closing{-webkit-transform:translateX(-100%);transform:translateX(-100%);-webkit-transition-duration:200ms;transition-duration:200ms;}[dir=rtl] .mdc-drawer--closing,.mdc-drawer--closing[dir=rtl]{-webkit-transform:translateX(100%);transform:translateX(100%);}.mdc-drawer__header{-ms-flex-negative:0;flex-shrink:0;-webkit-box-sizing:border-box;box-sizing:border-box;min-height:64px;padding:0 16px 4px;}.mdc-drawer__title{font-family:Roboto,sans-serif;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;font-size:1.25rem;line-height:2rem;font-weight:500;letter-spacing:0.0125em;text-decoration:inherit;text-transform:inherit;display:block;margin-top:0;line-height:normal;margin-bottom:-20px;}.mdc-drawer__title::before{display:inline-block;width:0;height:36px;content:\"\";vertical-align:0;}.mdc-drawer__title::after{display:inline-block;width:0;height:20px;content:\"\";vertical-align:-20px;}.mdc-drawer__subtitle{font-family:Roboto,sans-serif;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;font-size:0.875rem;line-height:1.25rem;font-weight:400;letter-spacing:0.0178571429em;text-decoration:inherit;text-transform:inherit;display:block;margin-top:0;line-height:normal;margin-bottom:0;}.mdc-drawer__subtitle::before{display:inline-block;width:0;height:20px;content:\"\";vertical-align:0;}.mdc-drawer__content{height:100%;overflow-y:auto;-webkit-overflow-scrolling:touch;}.mdc-drawer--dismissible{left:0;right:initial;display:none;position:absolute;}[dir=rtl] .mdc-drawer--dismissible,.mdc-drawer--dismissible[dir=rtl]{left:initial;right:0;}.mdc-drawer--dismissible.mdc-drawer--open{display:-ms-flexbox;display:flex;}.mdc-drawer-app-content{margin-left:0;margin-right:0;position:relative;}[dir=rtl] .mdc-drawer-app-content,.mdc-drawer-app-content[dir=rtl]{margin-left:0;margin-right:0;}.mdc-drawer--modal{-webkit-box-shadow:0px 8px 10px -5px rgba(0,0,0,0.2),0px 16px 24px 2px rgba(0,0,0,0.14),0px 6px 30px 5px rgba(0,0,0,0.12);box-shadow:0px 8px 10px -5px rgba(0,0,0,0.2),0px 16px 24px 2px rgba(0,0,0,0.14),0px 6px 30px 5px rgba(0,0,0,0.12);left:0;right:initial;display:none;position:fixed;}.mdc-drawer--modal+.mdc-drawer-scrim{background-color:rgba(0,0,0,0.32);}[dir=rtl] .mdc-drawer--modal,.mdc-drawer--modal[dir=rtl]{left:initial;right:0;}.mdc-drawer--modal.mdc-drawer--open{display:-ms-flexbox;display:flex;}.mdc-drawer-scrim{display:none;position:fixed;top:0;left:0;width:100%;height:100%;-webkit-transition-property:opacity;transition-property:opacity;-webkit-transition-timing-function:cubic-bezier(0.4,0,0.2,1);transition-timing-function:cubic-bezier(0.4,0,0.2,1);z-index:5;}.mdc-drawer--open+.mdc-drawer-scrim{display:block;}.mdc-drawer--animate+.mdc-drawer-scrim{opacity:0;}.mdc-drawer--opening+.mdc-drawer-scrim{-webkit-transition-duration:250ms;transition-duration:250ms;opacity:1;}.mdc-drawer--closing+.mdc-drawer-scrim{-webkit-transition-duration:200ms;transition-duration:200ms;opacity:0;}.mdc-top-app-bar{background-color:#6200ee;background-color:var(--mdc-theme-primary,#6200ee);color:white;display:-ms-flexbox;display:flex;position:fixed;-ms-flex-direction:column;flex-direction:column;-ms-flex-pack:justify;justify-content:space-between;-webkit-box-sizing:border-box;box-sizing:border-box;width:100%;z-index:4;}.mdc-top-app-bar .mdc-top-app-bar__action-item,.mdc-top-app-bar .mdc-top-app-bar__navigation-icon{color:#fff;color:var(--mdc-theme-on-primary,#fff);}.mdc-top-app-bar .mdc-top-app-bar__action-item::before,.mdc-top-app-bar .mdc-top-app-bar__action-item::after,.mdc-top-app-bar .mdc-top-app-bar__navigation-icon::before,.mdc-top-app-bar .mdc-top-app-bar__navigation-icon::after{background-color:#fff;}\@supports not (-ms-ime-align:auto){.mdc-top-app-bar .mdc-top-app-bar__action-item::before,.mdc-top-app-bar .mdc-top-app-bar__action-item::after,.mdc-top-app-bar .mdc-top-app-bar__navigation-icon::before,.mdc-top-app-bar .mdc-top-app-bar__navigation-icon::after{background-color:var(--mdc-theme-on-primary,#fff);}}.mdc-top-app-bar .mdc-top-app-bar__action-item:hover::before,.mdc-top-app-bar .mdc-top-app-bar__navigation-icon:hover::before{opacity:0.08;}.mdc-top-app-bar .mdc-top-app-bar__action-item:not(.mdc-ripple-upgraded):focus::before,.mdc-top-app-bar .mdc-top-app-bar__action-item.mdc-ripple-upgraded--background-focused::before,.mdc-top-app-bar .mdc-top-app-bar__navigation-icon:not(.mdc-ripple-upgraded):focus::before,.mdc-top-app-bar .mdc-top-app-bar__navigation-icon.mdc-ripple-upgraded--background-focused::before{-webkit-transition-duration:75ms;transition-duration:75ms;opacity:0.24;}.mdc-top-app-bar .mdc-top-app-bar__action-item:not(.mdc-ripple-upgraded)::after,.mdc-top-app-bar .mdc-top-app-bar__navigation-icon:not(.mdc-ripple-upgraded)::after{-webkit-transition:opacity 150ms linear;transition:opacity 150ms linear;}.mdc-top-app-bar .mdc-top-app-bar__action-item:not(.mdc-ripple-upgraded):active::after,.mdc-top-app-bar .mdc-top-app-bar__navigation-icon:not(.mdc-ripple-upgraded):active::after{-webkit-transition-duration:75ms;transition-duration:75ms;opacity:0.24;}.mdc-top-app-bar .mdc-top-app-bar__action-item.mdc-ripple-upgraded,.mdc-top-app-bar .mdc-top-app-bar__navigation-icon.mdc-ripple-upgraded{--mdc-ripple-fg-opacity:0.24;}.mdc-top-app-bar__row{display:-ms-flexbox;display:flex;position:relative;-webkit-box-sizing:border-box;box-sizing:border-box;width:100%;height:64px;}.mdc-top-app-bar__section{display:-ms-inline-flexbox;display:inline-flex;-ms-flex:1 1 auto;flex:1 1 auto;-ms-flex-align:center;align-items:center;min-width:0;padding:8px 12px;z-index:1;}.mdc-top-app-bar__section--align-start{-ms-flex-pack:start;justify-content:flex-start;-ms-flex-order:-1;order:-1;}.mdc-top-app-bar__section--align-end{-ms-flex-pack:end;justify-content:flex-end;-ms-flex-order:1;order:1;}.mdc-top-app-bar__title{font-family:Roboto,sans-serif;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;font-size:1.25rem;line-height:2rem;font-weight:500;letter-spacing:0.0125em;text-decoration:inherit;text-transform:inherit;padding-left:20px;padding-right:0;text-overflow:ellipsis;white-space:nowrap;overflow:hidden;z-index:1;}[dir=rtl] .mdc-top-app-bar__title,.mdc-top-app-bar__title[dir=rtl]{padding-left:0;padding-right:20px;}.mdc-top-app-bar__action-item,.mdc-top-app-bar__navigation-icon{--mdc-ripple-fg-size:0;--mdc-ripple-left:0;--mdc-ripple-top:0;--mdc-ripple-fg-scale:1;--mdc-ripple-fg-translate-end:0;--mdc-ripple-fg-translate-start:0;-webkit-tap-highlight-color:rgba(0,0,0,0);display:-ms-flexbox;display:flex;position:relative;-ms-flex-negative:0;flex-shrink:0;-ms-flex-align:center;align-items:center;-ms-flex-pack:center;justify-content:center;-webkit-box-sizing:border-box;box-sizing:border-box;width:48px;height:48px;padding:12px;border:none;outline:none;background-color:transparent;fill:currentColor;color:inherit;text-decoration:none;cursor:pointer;}.mdc-top-app-bar__action-item::before,.mdc-top-app-bar__action-item::after,.mdc-top-app-bar__navigation-icon::before,.mdc-top-app-bar__navigation-icon::after{position:absolute;border-radius:50%;opacity:0;pointer-events:none;content:\"\";}.mdc-top-app-bar__action-item::before,.mdc-top-app-bar__navigation-icon::before{-webkit-transition:opacity 15ms linear,background-color 15ms linear;transition:opacity 15ms linear,background-color 15ms linear;z-index:1;}.mdc-top-app-bar__action-item.mdc-ripple-upgraded::before,.mdc-top-app-bar__navigation-icon.mdc-ripple-upgraded::before{-webkit-transform:scale(var(--mdc-ripple-fg-scale,1));transform:scale(var(--mdc-ripple-fg-scale,1));}.mdc-top-app-bar__action-item.mdc-ripple-upgraded::after,.mdc-top-app-bar__navigation-icon.mdc-ripple-upgraded::after{top:0;left:0;-webkit-transform:scale(0);transform:scale(0);-webkit-transform-origin:center center;transform-origin:center center;}.mdc-top-app-bar__action-item.mdc-ripple-upgraded--unbounded::after,.mdc-top-app-bar__navigation-icon.mdc-ripple-upgraded--unbounded::after{top:var(--mdc-ripple-top,0);left:var(--mdc-ripple-left,0);}.mdc-top-app-bar__action-item.mdc-ripple-upgraded--foreground-activation::after,.mdc-top-app-bar__navigation-icon.mdc-ripple-upgraded--foreground-activation::after{-webkit-animation:mdc-ripple-fg-radius-in 225ms forwards,mdc-ripple-fg-opacity-in 75ms forwards;animation:mdc-ripple-fg-radius-in 225ms forwards,mdc-ripple-fg-opacity-in 75ms forwards;}.mdc-top-app-bar__action-item.mdc-ripple-upgraded--foreground-deactivation::after,.mdc-top-app-bar__navigation-icon.mdc-ripple-upgraded--foreground-deactivation::after{-webkit-animation:mdc-ripple-fg-opacity-out 150ms;animation:mdc-ripple-fg-opacity-out 150ms;-webkit-transform:translate(var(--mdc-ripple-fg-translate-end,0)) scale(var(--mdc-ripple-fg-scale,1));transform:translate(var(--mdc-ripple-fg-translate-end,0)) scale(var(--mdc-ripple-fg-scale,1));}.mdc-top-app-bar__action-item::before,.mdc-top-app-bar__action-item::after,.mdc-top-app-bar__navigation-icon::before,.mdc-top-app-bar__navigation-icon::after{top:calc(50% - 50%);left:calc(50% - 50%);width:100%;height:100%;}.mdc-top-app-bar__action-item.mdc-ripple-upgraded::before,.mdc-top-app-bar__action-item.mdc-ripple-upgraded::after,.mdc-top-app-bar__navigation-icon.mdc-ripple-upgraded::before,.mdc-top-app-bar__navigation-icon.mdc-ripple-upgraded::after{top:var(--mdc-ripple-top,calc(50% - 50%));left:var(--mdc-ripple-left,calc(50% - 50%));width:var(--mdc-ripple-fg-size,100%);height:var(--mdc-ripple-fg-size,100%);}.mdc-top-app-bar__action-item.mdc-ripple-upgraded::after,.mdc-top-app-bar__navigation-icon.mdc-ripple-upgraded::after{width:var(--mdc-ripple-fg-size,100%);height:var(--mdc-ripple-fg-size,100%);}.mdc-top-app-bar--short-collapsed{border-radius:0 0 24px 0;}[dir=rtl] .mdc-top-app-bar--short-collapsed,.mdc-top-app-bar--short-collapsed[dir=rtl]{border-radius:0 0 0 24px;}.mdc-top-app-bar--short{top:0;right:auto;left:0;width:100%;-webkit-transition:width 250ms cubic-bezier(0.4,0,0.2,1);transition:width 250ms cubic-bezier(0.4,0,0.2,1);}[dir=rtl] .mdc-top-app-bar--short,.mdc-top-app-bar--short[dir=rtl]{right:0;left:auto;}.mdc-top-app-bar--short .mdc-top-app-bar__row{height:56px;}.mdc-top-app-bar--short .mdc-top-app-bar__section{padding:4px;}.mdc-top-app-bar--short .mdc-top-app-bar__title{-webkit-transition:opacity 200ms cubic-bezier(0.4,0,0.2,1);transition:opacity 200ms cubic-bezier(0.4,0,0.2,1);opacity:1;}.mdc-top-app-bar--short-collapsed{-webkit-box-shadow:0px 2px 4px -1px rgba(0,0,0,0.2),0px 4px 5px 0px rgba(0,0,0,0.14),0px 1px 10px 0px rgba(0,0,0,0.12);box-shadow:0px 2px 4px -1px rgba(0,0,0,0.2),0px 4px 5px 0px rgba(0,0,0,0.14),0px 1px 10px 0px rgba(0,0,0,0.12);width:56px;-webkit-transition:width 300ms cubic-bezier(0.4,0,0.2,1);transition:width 300ms cubic-bezier(0.4,0,0.2,1);}.mdc-top-app-bar--short-collapsed .mdc-top-app-bar__title{display:none;}.mdc-top-app-bar--short-collapsed .mdc-top-app-bar__action-item{-webkit-transition:padding 150ms cubic-bezier(0.4,0,0.2,1);transition:padding 150ms cubic-bezier(0.4,0,0.2,1);}.mdc-top-app-bar--short-collapsed.mdc-top-app-bar--short-has-action-item{width:112px;}.mdc-top-app-bar--short-collapsed.mdc-top-app-bar--short-has-action-item .mdc-top-app-bar__section--align-end{padding-left:0;padding-right:12px;}[dir=rtl] .mdc-top-app-bar--short-collapsed.mdc-top-app-bar--short-has-action-item .mdc-top-app-bar__section--align-end,.mdc-top-app-bar--short-collapsed.mdc-top-app-bar--short-has-action-item .mdc-top-app-bar__section--align-end[dir=rtl]{padding-left:12px;padding-right:0;}.mdc-top-app-bar--dense .mdc-top-app-bar__row{height:48px;}.mdc-top-app-bar--dense .mdc-top-app-bar__section{padding:0 4px;}.mdc-top-app-bar--dense .mdc-top-app-bar__title{padding-left:12px;padding-right:0;}[dir=rtl] .mdc-top-app-bar--dense .mdc-top-app-bar__title,.mdc-top-app-bar--dense .mdc-top-app-bar__title[dir=rtl]{padding-left:0;padding-right:12px;}.mdc-top-app-bar--prominent .mdc-top-app-bar__row{height:128px;}.mdc-top-app-bar--prominent .mdc-top-app-bar__title{-ms-flex-item-align:end;align-self:flex-end;padding-bottom:2px;}.mdc-top-app-bar--prominent .mdc-top-app-bar__action-item,.mdc-top-app-bar--prominent .mdc-top-app-bar__navigation-icon{-ms-flex-item-align:start;align-self:flex-start;}.mdc-top-app-bar--fixed{-webkit-transition:-webkit-box-shadow 200ms linear;transition:-webkit-box-shadow 200ms linear;transition:box-shadow 200ms linear;transition:box-shadow 200ms linear,-webkit-box-shadow 200ms linear;}.mdc-top-app-bar--fixed-scrolled{-webkit-box-shadow:0px 2px 4px -1px rgba(0,0,0,0.2),0px 4px 5px 0px rgba(0,0,0,0.14),0px 1px 10px 0px rgba(0,0,0,0.12);box-shadow:0px 2px 4px -1px rgba(0,0,0,0.2),0px 4px 5px 0px rgba(0,0,0,0.14),0px 1px 10px 0px rgba(0,0,0,0.12);-webkit-transition:-webkit-box-shadow 200ms linear;transition:-webkit-box-shadow 200ms linear;transition:box-shadow 200ms linear;transition:box-shadow 200ms linear,-webkit-box-shadow 200ms linear;}.mdc-top-app-bar--dense.mdc-top-app-bar--prominent .mdc-top-app-bar__row{height:96px;}.mdc-top-app-bar--dense.mdc-top-app-bar--prominent .mdc-top-app-bar__section{padding:0 12px;}.mdc-top-app-bar--dense.mdc-top-app-bar--prominent .mdc-top-app-bar__title{padding-left:20px;padding-right:0;padding-bottom:9px;}[dir=rtl] .mdc-top-app-bar--dense.mdc-top-app-bar--prominent .mdc-top-app-bar__title,.mdc-top-app-bar--dense.mdc-top-app-bar--prominent .mdc-top-app-bar__title[dir=rtl]{padding-left:0;padding-right:20px;}.mdc-top-app-bar--fixed-adjust{padding-top:64px;}.mdc-top-app-bar--dense-fixed-adjust{padding-top:48px;}.mdc-top-app-bar--short-fixed-adjust{padding-top:56px;}.mdc-top-app-bar--prominent-fixed-adjust{padding-top:128px;}.mdc-top-app-bar--dense-prominent-fixed-adjust{padding-top:96px;}\@media (max-width:599px){.mdc-top-app-bar__row{height:56px;}.mdc-top-app-bar__section{padding:4px;}.mdc-top-app-bar--short{-webkit-transition:width 200ms cubic-bezier(0.4,0,0.2,1);transition:width 200ms cubic-bezier(0.4,0,0.2,1);}.mdc-top-app-bar--short-collapsed{-webkit-transition:width 250ms cubic-bezier(0.4,0,0.2,1);transition:width 250ms cubic-bezier(0.4,0,0.2,1);}.mdc-top-app-bar--short-collapsed .mdc-top-app-bar__section--align-end{padding-left:0;padding-right:12px;}[dir=rtl] .mdc-top-app-bar--short-collapsed .mdc-top-app-bar__section--align-end,.mdc-top-app-bar--short-collapsed .mdc-top-app-bar__section--align-end[dir=rtl]{padding-left:12px;padding-right:0;}.mdc-top-app-bar--prominent .mdc-top-app-bar__title{padding-bottom:6px;}.mdc-top-app-bar--fixed-adjust{padding-top:56px;}}\@font-face{font-family:\"Material Icons\";font-style:normal;font-weight:400;src:url(MaterialIcons-Regular.eot);src:local(\"Material Icons\"),local(\"MaterialIcons-Regular\"),url(MaterialIcons-Regular.woff2) format(\"woff2\"),url(MaterialIcons-Regular.woff) format(\"woff\"),url(MaterialIcons-Regular.ttf) format(\"truetype\");}.material-icons{font-family:\"Material Icons\";font-weight:normal;font-style:normal;font-size:24px;display:inline-block;line-height:1;text-transform:none;letter-spacing:normal;word-wrap:normal;white-space:nowrap;direction:ltr;-webkit-font-smoothing:antialiased;text-rendering:optimizeLegibility;-moz-osx-font-smoothing:grayscale;-webkit-font-feature-settings:\"liga\";font-feature-settings:\"liga\";}:host{display:-ms-flexbox;display:flex;height:100vh;}.mdc-drawer-app-content{-ms-flex:auto;flex:auto;overflow:auto;position:relative;}.main-content{overflow:auto;height:100%;}.mdc-top-app-bar{position:absolute;}.mdc-top-app-bar{z-index:7;}"; },
        enumerable: true,
        configurable: true
    });
    return class_1;
}());
export { DrawerWithTopAppBar as materials_drawer_with_top_app_bar };
