import { EventEmitter } from '../../stencil-public-runtime';
export declare class Select {
    private selectEl;
    private mdcSelect;
    private mdcHelperText;
    private mdcNotchedOutline;
    private selectTagEl;
    private notchedOutlineEl;
    host: HTMLMaterialsSelectElement;
    select: EventEmitter;
    change: EventEmitter;
    disabled: boolean;
    box: boolean;
    dense: boolean;
    outlined: boolean;
    required: boolean;
    defaultEmpty: boolean;
    label: string;
    name: string;
    width: string;
    leadingIcon: string;
    helperText: string;
    value: any;
    customValidation: () => Promise<string>;
    options: Map<string | number, string>;
    realHelperText: string;
    componentDidLoad(): Promise<void>;
    componentDidUnload(): Promise<void>;
    watchOptions(): Promise<void>;
    watchValue(): Promise<void>;
    watchDisabled(): Promise<void>;
    isValid(): Promise<boolean>;
    forceValidation(): Promise<void>;
    getClasses(): {
        'materials-select': boolean;
        'mdc-select': boolean;
        'mdc-select--box': boolean;
        'mdc-select--disabled': boolean;
        'mdc-select--outlined': boolean;
        'mdc-select--with-leading-icon': boolean;
        'materials-select--dense': boolean;
    };
    getLabelClass(): {
        'mdc-floating-label': boolean;
    };
    private initMdcSelect;
    private destroyMdc;
    render(): any[];
}
