import { EventEmitter } from '../../stencil-public-runtime';
export declare class Step {
    host: HTMLElement;
    status: 'valid' | 'invalid' | 'empty';
    stepTitle: string;
    index: number;
    isLast: boolean;
    active: boolean;
    optional: boolean;
    editable: boolean;
    showButtons: boolean;
    confirmationText: string;
    summary: string;
    noPadding: boolean;
    private header;
    private body;
    stepClick: EventEmitter;
    previousStep: EventEmitter;
    submitStep: EventEmitter;
    submitStepper: EventEmitter;
    componentDidLoad(): void;
    getStepClasses(): {
        'step': boolean;
        'mdc-typography': boolean;
        'step-editable': boolean;
        'step-active': boolean;
        'step-valid': boolean;
        'step-empty': boolean;
        'step-invalid': boolean;
        'step-last': boolean;
    };
    getStepIconContent(): any;
    getStepIconClasses(): {
        'step-icon': boolean;
        'step-icon-valid': boolean;
        'step-icon-invalid': boolean;
    };
    getStepBodyClasses(): {
        'step-body': boolean;
        'no-padding': boolean;
        'step-body-active': boolean;
    };
    handleClickNext(): void;
    handleClickFinish(): void;
    handleClickPrevious(): void;
    adjustHeight(): Promise<void>;
    handleLast(): void;
    render(): any;
}
